const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const content_folders = sequelize.define(
    'content_folders',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  content_folders.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























    db.content_folders.hasMany(db.content_items, {
      as: 'content_items_folder',
      foreignKey: {
          name: 'folderId',
      },
      constraints: false,
    });







//end loop



    db.content_folders.belongsTo(db.companies, {
      as: 'company',
      foreignKey: {
        name: 'companyId',
      },
      constraints: false,
    });

    db.content_folders.belongsTo(db.content_folders, {
      as: 'parent_folder',
      foreignKey: {
        name: 'parent_folderId',
      },
      constraints: false,
    });




    db.content_folders.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.content_folders.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return content_folders;
};


